#pragma once

#include <functional>
#include "windef.h"
#include "wc3/command_bar.hpp"

struct CommandKey {
	DWORD ability_id;
	DWORD order_id;

	CommandKey(const CCommandButtonData& data);

	bool operator == (const CommandKey& other) const;
	bool operator != (const CommandKey& other) const;
};

template<> struct std::hash<CommandKey> {
	size_t operator () (const CommandKey& key) const {
		std::hash<DWORD> hasher;
		return hasher(key.ability_id) ^ hasher(key.order_id);
	}
};

void set_command_hidden(const CommandKey& key, bool state);
bool is_command_hidden(const CommandKey& key);
void reset_hidden_commands();
void set_command_position(const CommandKey& key, const POINT& position);
bool reset_command_position(const CommandKey& key);
bool get_command_position(const CommandKey& key, POINT& position);
void set_default_hotkeys_disabled(bool state);

bool command_overrides_initialize();
bool command_overrides_finalize();
