#pragma once

#include <cstdio>
#include <string>

template<typename... Args>
bool format(std::string& buffer, const char* format, Args&&... args) {
	int count = std::snprintf(nullptr, 0, format, args...);
	if (count >= 0) {
		auto size = static_cast<size_t>(count);
		buffer.resize(size);
		std::snprintf(buffer.data(), buffer.size(), format, args...);
		return true;
	}

	return false;
}
