#include "hook.hpp"

#include <cstdio>
#include "MinHook.h"
#include "application.hpp"

bool hook(const char* name, void* source, void* destination, void** trumpline) {
	MH_STATUS status;

	status = MH_CreateHook(source, destination, trumpline);
	if (status != MH_OK) {
		fprintf(stderr, "[%s] Failed to create hook for function «%s» at 0x%.8X. Error code = %d\n", APPLICATION_NAME, name, source, status);
		return false;
	}

	status = MH_EnableHook(source);
	if (status != MH_OK) {
		fprintf(stderr, "[%s] Failed to enable hook for function «%s». Error code = %d\n", APPLICATION_NAME, name, status);
		return false;
	}

	return true;
}

bool unhook(const char* name, void* source) {
	MH_STATUS status = MH_RemoveHook(source);
	if (status != MH_OK) {
		fprintf(stderr, "[%s] Failed to remove hook for function «%s». Error code = %d\n", APPLICATION_NAME, name, status);
		return false;
	}

	return true;
}

bool hook_initialize() {
	MH_STATUS status = MH_Initialize();
	if (status != MH_OK) {
		fprintf(stderr, "[%s] Failed to initialize MinHook. Error code = %d\n", APPLICATION_NAME, status);
		return false;
	}

	return true;
}

bool hook_finalize() {
	MH_STATUS status = MH_Uninitialize();
	if (status != MH_OK) {
		fprintf(stderr, "[%s] MH_Uninitialize call failed. Error code = %d\n", APPLICATION_NAME, status);
		return false;
	}

	return true;
}
