#pragma once

#include "hotkey_system.hpp"
#include <string>

using std::string;
using std::vector;

bool key_name_to_key_code(const char* key_name, DWORD& key_code);
bool key_code_to_modifier(DWORD key_code, hotkey_system::KeyModifier& modifier);
bool key_names_to_key_codes(const vector<string>& key_names, vector<DWORD>& key_codes);

template<typename Range>
bool key_codes_to_modifiers(Range key_codes, int& modifiers) {
	modifiers = 0;

	for (DWORD key_code : key_codes) {
		hotkey_system::KeyModifier modifier;
		if (!key_code_to_modifier(key_code, modifier)) {
			return false;
		}
		modifiers |= static_cast<int>(modifier);
	}

	return true;
}

bool try_parse_hotkey_modifiers(const char* modifiers_string, int& modifiers);
bool try_parse_hotkey(const char* hotkey_string, hotkey_system::Hotkey& hotkey);
bool hotkey_parser_initialize();
